<div class="container-fluid mb-4">
	<h3>{{title}}</h3>
</div>
<div class="container-fluid mb-4">
	<div class="row">
		<div class="col-4">
			<div>
				<button type="button" class="btn btn-warning" id="add_button" onclick="document.getElementById('form_wrapper').classList.remove('hide');this.classList.add('hide')">Add new counter</button>
			</div>

			<div class="card hide" id="form_wrapper">
				<form id="create_counter">
					<div class="card-header">
						<div class="h5 mb-0">New counter</div>
					</div>
					<div class="card-body">
						<div class="form-group">
							<label for="name">Counter name <span class="text-danger">*</span></label>
							<input type="text" class="form-control" id="name" name="name">
							<small id="name_help" class="form-text text-muted">Custom counter's name</small>
						</div>
						<div class="form-group">
							<label for="target_url">Target URL</label>
							<input type="url" class="form-control" id="target_url" value="http://" name="target_url">
							<small id="target_url_help" class="form-text text-muted">Custom counter's name</small>
						</div>
						<div class="form-group">
							<label for="google_line_item_id">Google line item ID</label>
							<input type="text" class="form-control" id="google_line_item_id" name="google_line_item_id">
							<small id="google_line_item_id_help" class="form-text text-muted">ID of line item from google adManager</small>
						</div>
						<div class="form-group">
							<label for="start_counting">Start counting date</label>
							<input type="text" class="form-control" id="start_counting" name="start_counting" placeholder="YYYY-MM-DD">
							<small id="start_counting_help" class="form-text text-muted">Leave blank for start counting immediately.</small>
						</div>
						<div class="form-group">
							<label for="end_counting">End counting date</label>
							<input type="text" class="form-control" id="end_counting" name="end_counting" placeholder="YYYY-MM-DD">
							<small id="end_counting_help" class="form-text text-muted">Leave blank for endless counting.</small>
						</div>

						<button type="submit" class="btn btn-primary">Create new counter</button>
						<button type="button" class="btn btn-secondary" onclick="document.getElementById('add_button').classList.remove('hide');document.getElementById('form_wrapper').classList.add('hide')">Close</button>
					</div>
				</form>
			</div>
		</div>
	</div>
</div>

<div class="container-fluid">

	<div class="alert alert-primary h6" style="display: inline-block">
		<span class="badge badge-light ">{{counterListCount}}</span> records
	</div>
	<table class="table table-sm table-striped table-hover" id="list_table">
		<thead>
		<tr>
			<th>Hash</th>
			<th>Counter name</th>
			<th>Line Item ID</th>
			<th>Impression</th>
			<th>Click</th>
			<th>Start</th>
			<th>End</th>
			<th>Target URL</th>
			<th>Created</th>
			<th>&nbsp;</th>
			<th>&nbsp;</th>
		</tr>
		</thead>
		<tbody>
		{{#each counterList}}
			<tr>
				<td>{{hash}}</td>
				<td>{{name}}</td>
				<td>{{google_line_item_id}}</td>
				<td>{{impression_count}}</td>
				<td>{{click_count}}</td>
				<td>{{start_counting}}</td>
				<td>{{end_counting}}</td>
				<td>{{{target_url}}}</td>
				<td>{{created}}</td>
				<td><a href="/article/{{hash}}" target="_blank">article example</a></td>
				<td><a href="/csv?id={{id}}">csv</a></td>
			</tr>
		{{/each}}
		</tbody>
	</table>
</div>
<script type="application/javascript">
	var resultWrapper = document.getElementById('insert_result');
	var formWrapper = document.getElementById('insert_form');

	function insertText(key, text) {
		if (document.getElementById('new_' + key)) {
			document.getElementById('new_' + key).innerHTML = text || '&lt;not set&gt;';
		}
	}

	function createRecord(e) {
		e.preventDefault();
		var items = document.getElementById('create_counter');
		var data = {};

		for (var i = 0; i < items.length; i++) {
			var item = items[i];
			if (item.type === 'text' || item.type === 'url') {
				data[item.name] = item.value;
			}
		}

		if(!data.name) {
			return Swal.fire({
				title: 'Error!',
				text: 'Counter name is REQUIRED!',
				icon: 'error',
				confirmButtonText: 'Close'
			})
		}
		data.target_url = data.target_url ? encodeURIComponent(data.target_url.trim()) : null;

		axios.post('/api/create-counter', data)
			.then(result => {
				Object.keys(result.data)
					.forEach(itemKey => {
						insertText(itemKey, result.data[itemKey]);
					});

				var list_table = document.getElementById('list_table').getElementsByTagName('tbody')[0];
				var row = list_table.insertRow(0);
				row.insertCell(-1).innerHTML = result.data.hash;
				row.insertCell(-1).innerHTML = result.data.name;
				row.insertCell(-1).innerHTML = result.data.google_line_item_id || '-';
				row.insertCell(-1).innerHTML = 0;
				row.insertCell(-1).innerHTML = 0;
				row.insertCell(-1).innerHTML = (result.data.start_counting || '-');
				row.insertCell(-1).innerHTML = (result.data.end_counting || '-');
				row.insertCell(-1).innerHTML = result.data.target_url ? 'YES' : '-';
				row.insertCell(-1).innerHTML = result.data.created;
				row.insertCell(-1).innerHTML = '<a href="/article/'+result.data.hash+'" target="_blank">article example</a>';
				row.insertCell(-1).innerHTML = '<a href="/csv?id='+result.data.id+'">csv</a>';

				Swal.fire({
					title: 'Success',
					width: '1000px',
					html: '<div>Counter name: <span class="badge badge-success">'+result.data.name+'</span></div>' +
						'<div>Hash: <span class="badge badge-success">'+result.data.hash+'</span></div>' +
						'<div>Target URL:</div><div class="badge badge-success">'+result.data.target_url+'</div></div>' +
						'<div>Google line item ID: <span class="badge badge-success">'+(result.data.google_line_item_id || '-')+'</span></div>' +
						'<div>Start counting: <span class="badge badge-success">'+(result.data.start_counting || 'immediately') +'</span></div>' +
						'<div>End counting: <span class="badge badge-success">'+(result.data.end_counting || 'never')+'</span></div>'+
						'<br />'+
						'<div>Tracking image:</div>'+
						'<div><pre>&lt;img src="http://domain.tld/c/i?hash='+result.data.hash+'" &sol;&gt;</pre></div>'+
						'<br />'+
						'<div>Link:</div>'+
						'<div><pre>&lt;a href="http://domain.tld/c/c?hash='+result.data.hash+'&amp;url='+result.data.target_url+'" &gt;&lt;&sol;a&gt;</pre></div>',
					icon: 'success',
					confirmButtonText: 'Close'
				});
			})
			.catch(error => {
				console.log('ERROR');
				console.log(error);
				console.log(error.data);

				Swal.fire({
					title: 'Error!',
					text: error.data.msg,
					icon: 'error',
					confirmButtonText: 'Close'
				});
			});

		return;
	}

	document.getElementById('create_counter')
		.addEventListener('submit', createRecord, false)
</script>